Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 673472 - net-libs/zeromq-4.3.0: test failures (tests/test_security_zap, tests/test_security_curve) fail with SIGBUS
Summary: net-libs/zeromq-4.3.0: test failures (tests/test_security_zap, tests/test_sec...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Thomas Deutschmann
URL:
Whiteboard:
Keywords: TESTFAILURE
Depends on:
Blocks: unaligned-access 673436
  Show dependency tree
 
Reported: 2018-12-20 09:01 UTC by Rolf Eike Beer
Modified: 2019-01-15 21:27 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (net-libs_zeromq-4.3.0_use_5L3zn,221.00 KB, text/plain)
2018-12-20 09:01 UTC, Rolf Eike Beer
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Rolf Eike Beer 2018-12-20 09:01:04 UTC
Created attachment 558194 [details]
build.log

Portage 2.3.51 (python 2.7.15-final-0, default/linux/sparc/17.0, gcc-7.3.0, glibc-2.27-r6, 4.16.8 sparc64)
=================================================================
System uname: Linux-4.16.8-sparc64-sun4v-with-gentoo-2.4.1
KiB Mem:    33133328 total,  12521720 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Thu, 20 Dec 2018 01:15:01 +0000
sh bash 4.4_p12
ld GNU ld (Gentoo 2.30 p5) 2.30.0
distcc 3.2rc1 sparc-unknown-linux-gnu [disabled]
app-shells/bash:          4.4_p12::gentoo
dev-lang/perl:            5.24.3-r1::gentoo
dev-lang/python:          2.7.15::gentoo, 3.6.5::gentoo
dev-util/cmake:           3.9.6::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.4.1-r2::gentoo
sys-apps/openrc:          0.34.11::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.13.4-r2::gentoo, 1.15.1-r2::gentoo
sys-devel/binutils:       2.30-r4::gentoo
sys-devel/gcc:            7.3.0-r3::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.13::gentoo (virtual/os-headers)
sys-libs/glibc:           2.27-r6::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: git
    sync-uri: https://anongit.gentoo.org/git/repo/sync/gentoo.git
    priority: -1000
    sync-git-verify-commit-signature: yes

ACCEPT_KEYWORDS="sparc"
ACCEPT_LICENSE="* -@EULA"
CBUILD="sparc-unknown-linux-gnu"
CFLAGS="-O2 -mcpu=niagara2 -pipe -Wcast-align"
CHOST="sparc-unknown-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt /var/bind /var/qmail/alias /var/qmail/control"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php7.1/ext-active/ /etc/php/apache2-php7.2/ext-active/ /etc/php/cgi-php7.1/ext-active/ /etc/php/cgi-php7.2/ext-active/ /etc/php/cli-php7.1/ext-active/ /etc/php/cli-php7.2/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -mcpu=niagara2 -pipe -Wcast-align"
DISTDIR="/usr/portage/distfiles"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS=""
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS=""
GENTOO_MIRRORS="ftp://ftp.wh2.tu-dresden.de/pub/mirrors/gentoo ftp://ftp.join.uni-muenster.de/pub/linux/distributions/gentoo"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j20"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="acl berkdb big-endian bzip2 cli crypt cxx dri fortran gdbm iconv ipv6 libtirpc ncurses nls nptl openmp pam pcre readline sparc ssl tcpd unicode xattr zlib" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon plan sheets stage words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6 php7-1" POSTGRES_TARGETS="postgres9_5 postgres10" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6" RUBY_TARGETS="ruby23 ruby24" USERLAND="GNU" VIDEO_CARDS="fbdev glint mga r128 radeon dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Thomas Deutschmann gentoo-dev Security 2018-12-20 10:36:33 UTC
Can you report upstream or can you provide more information where this is happening (backtrace) so I can report?
Comment 2 Rolf Eike Beer 2018-12-21 14:10:31 UTC
Adding a bit of logging I was able to get this outputs:

+ ./tests/test_security_zap
NULL mechanism
test_zap_protocol_error wrong_version
Unexpected event: 0x2000, value = -172977600/0xf5b09240 (expected: 0x2000, value = 536870915/0x20000003)
test_security_zap: tests/testutil_security.hpp:474: int expect_monitor_event_multiple(void*, int, int, bool): Assertion `false' failed.
./config/test-driver: line 109: 47952 Aborted                 "$@"

+ ./tests/test_security_curve
tests/test_security_curve.cpp:619:test_curve_security_with_valid_credentials:PASS
Unexpected event: 0x800, value = 1879226424/0x7002b838 (expected: 0x2000, value = 285212673/0x11000001)
test_security_curve: tests/testutil_security.hpp:474: int expect_monitor_event_multiple(void*, int, int, bool): Assertion `false' failed.
./config/test-driver: line 109: 48003 Aborted                 "$@"
Comment 3 Rolf Eike Beer 2018-12-21 15:27:55 UTC
There are also a bunch of -Wcast-align warnings, especially when building the tests, that look like they should be replaced by memcpy() just to be sure.
Comment 4 Rolf Eike Beer 2018-12-21 15:53:03 UTC
Oh, the test results below showing assertion failures were actually happening _with_ the warnings in testutil_security.hpp fixed by using memcpy().
Comment 5 Larry the Git Cow gentoo-dev 2019-01-15 21:27:12 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1b14dc8e6719814848931eb231992ba237bbad33

commit 1b14dc8e6719814848931eb231992ba237bbad33
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2019-01-15 21:26:51 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2019-01-15 21:27:03 +0000

    net-libs/zeromq: fix test_security_zap
    
    Closes: https://bugs.gentoo.org/673472
    Package-Manager: Portage-2.3.56, Repoman-2.3.12
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 .../files/zeromq-4.3.1-fix-test_security_zap.patch | 25 ++++++++++++++++++++++
 net-libs/zeromq/zeromq-4.3.1.ebuild                |  2 +-
 2 files changed, 26 insertions(+), 1 deletion(-)